package com.diagbot.facade.data;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.diagbot.dto.data.ColumnZhAndChDTO;
import com.diagbot.entity.StrAdmissionNote;
import com.diagbot.service.impl.StrAdmissionNoteServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.MapUtil;
import com.diagbot.vo.data.AStrAdmissionNoteVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Component
public class AStrAdmissionNoteFacade extends StrAdmissionNoteServiceImpl {
    @Autowired
    private ColumnFacade columnFacade;
    @Autowired
    private AMedAbnormalInfoFacade aMedAbnormalInfoFacade;

    public void getColumnZhAndCh() {
        List<ColumnZhAndChDTO> list = this.baseMapper.getColumnZhAndCh();
        list.forEach(s -> {
            s.setEn(NamingStrategy.underlineToCamel(s.getEn()));
        });

        Map<String, String> columnMap = EntityUtil.makeMapWithKeyValue(list, "ch", "en");
        Boolean flag = columnFacade.createColumn(columnMap, "strAdmissionNote");

        //Map<String, String> map=columnFacade.getColumn("strAdmissionNote");
        if (!flag) {
            return;
        }
    }

    //入院记录
    public void dealData(String columnMap, Map<String, Object> entityMap, Long hospitalId) {
        StrAdmissionNote strAdmissionNote = new StrAdmissionNote();
        try {
            AStrAdmissionNoteVO strAdmissionNoteVO = (AStrAdmissionNoteVO) MapUtil.mapToObject(entityMap, AStrAdmissionNoteVO.class);
            BeanUtils.copyProperties(strAdmissionNoteVO, strAdmissionNote);
            strAdmissionNote.setHospitalId(hospitalId);//医院编码

            strAdmissionNote.setAuditDate(DateUtil.parseDateTime(strAdmissionNoteVO.getAuditDate()));//审核时间
            strAdmissionNote.setRecDate(DateUtil.parseDateTime(strAdmissionNoteVO.getRecDate()));//记录时间
            strAdmissionNote.setBehospitalDate(DateUtil.parseDateTime(strAdmissionNoteVO.getBehospitalDate()));//入院日期
            strAdmissionNote.setBirthday(DateUtil.parseDate(strAdmissionNoteVO.getBirthday()));//出生日期
            strAdmissionNote.setRecordDate(DateUtil.parseDateTime(strAdmissionNoteVO.getRecordDate()));//病历日期

            strAdmissionNote.setWholeData(columnMap);
            //判断数据库中是否存在，不存在insert
            if (isExist(strAdmissionNote)) {
                strAdmissionNote.setGmtCreate(new Date());//记录创建时间
                this.save(strAdmissionNote);
            } else {
                strAdmissionNote.setGmtModified(new Date());//记录修改时间
                this.update(strAdmissionNote, new QueryWrapper<StrAdmissionNote>()
                        .eq("rec_id", strAdmissionNote.getRecId())
                        .eq("hospital_id", strAdmissionNote.getHospitalId())
                        .eq("behospital_code", strAdmissionNote.getBehospitalCode()));
            }
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            aMedAbnormalInfoFacade.saveAbnormalInfo("入院记录", strAdmissionNote.getRecId(), JSON.toJSONString(entityMap), "", e.getMessage());
        }
    }

    public Boolean isExist(StrAdmissionNote strAdmissionNote) {
        Boolean flag = true;
        int count = this.baseMapper.selectCount(new QueryWrapper<StrAdmissionNote>()
                .eq("rec_id", strAdmissionNote.getRecId())
                .eq("hospital_id", strAdmissionNote.getHospitalId())
                .eq("behospital_code", strAdmissionNote.getBehospitalCode()));
        if (count > 0) {
            flag = false;
        }
        return flag;
    }

}
