package com.diagbot.facade.data;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.diagbot.dto.data.ColumnZhAndChDTO;
import com.diagbot.entity.StrConsultationResult;
import com.diagbot.service.impl.StrConsultationResultServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.MapUtil;
import com.diagbot.vo.data.AStrConsultationResultVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Component
public class AStrConsultationResultFacade extends StrConsultationResultServiceImpl {

    @Autowired
    private ColumnFacade columnFacade;
    @Autowired
    private AMedAbnormalInfoFacade aMedAbnormalInfoFacade;

    public void getColumnZhAndCh(){
        List<ColumnZhAndChDTO> list=this.baseMapper.getColumnZhAndCh();
        list.forEach(s->{
            s.setEn(NamingStrategy.underlineToCamel(s.getEn()));
        });

        Map<String, String> columnMap= EntityUtil.makeMapWithKeyValue(list,"ch","en");
        Boolean flag=columnFacade.createColumn(columnMap,"strConsultationResult");

        //Map<String, String> map=columnFacade.getColumn("strConsultationNote");
        if(!flag){
            return;
        }
    }

    //会诊结果单
    public void dealData(String columnMap,Map<String, Object> entityMap,Long hospitalId){
        StrConsultationResult strConsultationResult=new StrConsultationResult();
        try {
            AStrConsultationResultVO strConsultationResultVO=(AStrConsultationResultVO) MapUtil.mapToObject(entityMap, AStrConsultationResultVO.class);
            BeanUtils.copyProperties(strConsultationResultVO,strConsultationResult);
            strConsultationResult.setHospitalId(hospitalId);//医院编码

            strConsultationResult.setAuditDate(DateUtil.parseDateTime(strConsultationResultVO.getAuditDate()));//审核时间
            strConsultationResult.setRecDate(DateUtil.parseDateTime(strConsultationResultVO.getRecDate()));//记录时间
            strConsultationResult.setBehospitalDate(DateUtil.parseDateTime(strConsultationResultVO.getBehospitalDate()));//入院日期
            strConsultationResult.setApplyDate(DateUtil.parseDate(strConsultationResultVO.getApplyDate()));//申请时间
            strConsultationResult.setRecordDate(DateUtil.parseDateTime(strConsultationResultVO.getRecordDate()));//病历日期
            strConsultationResult.setConsultationArriveDate(DateUtil.parseDateTime(strConsultationResultVO.getConsultationArriveDate()));//会诊到达时间

            strConsultationResult.setWholeData(columnMap);
            //判断数据库中是否存在，不存在insert
            if(isExist(strConsultationResult)){
                strConsultationResult.setGmtCreate(new Date());//记录创建时间
                this.save(strConsultationResult);
            }else{
                strConsultationResult.setGmtModified(new Date());//记录修改时间
                this.update(strConsultationResult,new QueryWrapper<StrConsultationResult>()
                        .eq("rec_id", strConsultationResult.getRecId())
                        .eq("hospital_id", strConsultationResult.getHospitalId())
                        .eq("behospital_code", strConsultationResult.getBehospitalCode()));
            }

        }catch (Exception e){
            log.error(e.getMessage(),e);
            aMedAbnormalInfoFacade.saveAbnormalInfo("会诊结果单",strConsultationResult.getRecId(), JSON.toJSONString(entityMap),"",e.getMessage());
        }

    }

    public Boolean isExist(StrConsultationResult strConsultationResult){
        Boolean flag=true;
        int count = this.baseMapper.selectCount(new QueryWrapper<StrConsultationResult>()
                .eq("rec_id", strConsultationResult.getRecId())
                .eq("hospital_id", strConsultationResult.getHospitalId())
                .eq("behospital_code", strConsultationResult.getBehospitalCode()));
        if(count>0){
            flag=false;
        }
        return flag;
    }
}
